#include <cstdio>
#include <cmath>
#include <vector>
#include <algorithm>
using namespace std;

struct pt { pt(double x, double y) : x(x), y(y) {} double x,y; };

double det(pt u, pt v) {
    return u.x * v.y - u.y * v.x;
}
double vcp(pt a,pt b,pt c) {
    return det(pt(b.x - a.x, b.y - a.y), pt(c.x - a.x, c.y - a.y));
}
double inTri(vector<pt> pts,double x, double y) {
    return (((pts[0].x - pts[1].x) * (y - pts[0].y) - (pts[0].y - pts[1].y) * (x - pts[0].x) >= 0) &&
        ((pts[1].x - pts[2].x) * (y - pts[1].y) - (pts[1].y - pts[2].y) * (x - pts[1].x) >= 0) &&
        ((pts[2].x - pts[0].x) * (y - pts[2].y) - (pts[2].y - pts[0].y) * (x - pts[2].x) >= 0));
}

int main() {
    int testcases;
    scanf(" %d",&testcases);
 
    while (testcases--) {
        char board[35][35];
        for (int y=0; y<30; y++) {
            board[y][30] = 0;
            for (int x=0; x<30; x++) board[y][x] = '.';
        }

        int n;
        scanf(" %d",&n);
        while (n--) {
            vector<pt> pts;
            for (int i=0; i<3; i++) {
                double x,y;
                scanf(" %lf %lf",&x,&y);
                pts.push_back(pt(x,y));
            }

            // sort the triangle into counter-clockwise order
            if (vcp(pts[0],pts[1],pts[2]) > 0) swap(pts[1], pts[2]);

            for (int y=0; y<30; y++) {
                for (int x=0; x<30; x++) {
                    if (inTri(pts, x + 0.5, y + 0.5))
                        board[y][x] = '*';
                }
            }
        }

        for (int y=0; y<30; y++) {
            printf("%s\n",board[y]);
        }
        printf("\n");
    }
    return 0;
}