#include <cstdio>
#include <queue>
using namespace std;

struct node {
    node (int x,int y,int t) : x(x), y(y), t(t) { }
    int x,y,t;
};
bool operator<(const node &n1, const node &n2) {
    if (n1.t != n2.t) return n1.t > n2.t;
    if (n1.x != n2.x) return n1.x < n2.x;
    if (n1.y != n2.y) return n1.y < n2.y;
}

const int dir[4][2] = {{1,0},{-1,0},{0,1},{0,-1}};

int obstacles[55][2];
int getObstaclePos(int y, int t) {
    if (obstacles[y][0] == -1) return -1;
    int ox;
    int l = obstacles[y][1] - obstacles[y][0];
    if (l == 0) {
        ox = obstacles[y][0];
    } else if (l == 1) {
        ox = obstacles[y][0] + (t % 2);
    } else {
        ox = obstacles[y][0] + t % (l * 2);
        if (ox > obstacles[y][1]) ox = obstacles[y][1] - (ox - obstacles[y][1]);
    }
    return ox;
}

int main() {
    int n;
    scanf(" %d",&n);
    while (n--) {
        int w,h;
        scanf(" %d %d",&w,&h);
        char board[55][55];
        for (int i=0; i<h; i++) scanf(" %s", board[i]);

        int fx,fy;

        for (int y=0; y<h; y++) {
            obstacles[y][0] = obstacles[y][1] = -1;
            for (int x=0; x<w; x++) {
                if (board[y][x] == '-') {
                    obstacles[y][0] = x;
                    for (; x<w && board[y][x] == '-'; x++);
                    obstacles[y][1] = x-1;
                    x--;
                } else if (board[y][x] == 'F') {
                    fx = x; fy = y; board[y][x] = '.';
                }
            }
        }

        bool hit[55][55][200];
        for (int y=0; y<55; y++) for (int x=0; x<55; x++) for (int t=0; t<200; t++) hit[y][x][t] = false;

        priority_queue<node> q;
        q.push(node(fx,fy,0));
        bool good = false;
        while (!q.empty()) {
            node cur = q.top(); q.pop();
            if (hit[cur.x][cur.y][cur.t]) continue;
            hit[cur.x][cur.y][cur.t] = true;

            if (getObstaclePos(cur.y, cur.t) == cur.x) continue;
            if (getObstaclePos(cur.y, cur.t + 1) == cur.x) continue;

/*            printf("%d\n",cur.t);
            for (int y=0; y<h; y++) {
                for (int x=0; x<w; x++) {
                    if (getObstaclePos(y, cur.t) == x) printf("*");
                    else if (cur.x == x && cur.y == y) printf("F");
                    else printf("%c", board[y][x]);
                }
                printf("\n");
            }
            printf("\n");*/

            if (board[cur.y][cur.x] == 'P') {
                good = true;
                printf("%d\n", cur.t);
                break;
            }

            for (int i=0; i<4; i++) {
                int tx = cur.x + dir[i][0];
                int ty = cur.y + dir[i][1];
                if (tx < 0 || tx >= w || ty < 0 || ty >= h) continue;

                if (board[ty][tx] == '-') {
                    if (getObstaclePos(ty, cur.t + 1) == tx) continue;
                }

                q.push(node(tx, ty, cur.t + 1));
            }
        }

        if (!good) printf("Not solvable...\n");
    }

    return 0;
}