import java.io.*;
import java.util.*;

public class ESol {
    static int w, h;
    static char[][] board = new char[100][100];

    static boolean isFull(int r, int c, int t) {
	if (board[r][c] != '-') return false;

	int left = c, right = c;
	while (left-1 >= 0 && board[r][left-1] == '-') --left;
	while (right+1 < w && board[r][right+1] == '-') ++right;
	
	if (right == left) return true;

	int len = (right - left);
	int pos = right - Math.abs((t % (2*len)) - len);

	return pos == c;
    }

    public static void main(String[] args) throws Exception {
	BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
	int n = Integer.parseInt(in.readLine());
	input: while (n-- > 0) {
	    StringTokenizer tok = new StringTokenizer(in.readLine());
	    w = Integer.parseInt(tok.nextToken());
	    h = Integer.parseInt(tok.nextToken());
	    int fr = -1, fc = -1;
	    for (int r = 0; r < h; ++r) {
		String line = in.readLine();
		for (int c = 0; c < w; ++c) {
		    board[r][c] = line.charAt(c);
		    if (board[r][c] == 'F') {
			fr = r; fc = c;
		    }
		}
	    }

	    boolean[][][] visited = new boolean[55][55][100];
	    LinkedList q = new LinkedList();
	    q.add(new int[] { fr, fc, 0 });
	    while (!q.isEmpty()) {
		int[] pos = (int[]) q.removeFirst();
	       
		if (board[pos[0]][pos[1]] == 'P') {
		    System.out.println(pos[2]);
		    continue input;
		}

		if (visited[pos[0]][pos[1]][pos[2]]) continue;
		visited[pos[0]][pos[1]][pos[2]] = true;
		
		if (isFull(pos[0], pos[1], pos[2]) ||
		    isFull(pos[0], pos[1], pos[2] + 1)) continue;

		if (pos[0]+1 < h && !visited[pos[0]+1][pos[1]][pos[2]+1])
		    q.add(new int[] { pos[0] + 1, pos[1], pos[2] + 1 });

		if (pos[0]-1 >= 0 && !visited[pos[0]-1][pos[1]][pos[2]+1])
		    q.add(new int[] { pos[0] - 1, pos[1], pos[2] + 1 });

		if (pos[1]+1 < w && !visited[pos[0]][pos[1]+1][pos[2]+1])
		    q.add(new int[] { pos[0], pos[1] + 1, pos[2] + 1 });

		if (pos[1]-1 >= 0 && !visited[pos[0]][pos[1]-1][pos[2]+1])
		    q.add(new int[] { pos[0], pos[1] - 1, pos[2] + 1 });
	    }
	    System.out.println("That's unpossible!");
	}
    }
}
